#include <stdio.h>

extern struct rtpkt {
  int sourceid;       /* id of sending router sending this pkt */
  int destid;         /* id of router to which pkt being sent 
                         (must be an immediate neighbor) */
  int mincost[4];    /* min cost to node 0 ... 3 */
  };

extern int TRACE;
extern int YES;
extern int NO;

struct distance_table 
{
  int costs[4][4];
} dt3;


int connectcosts3[4] = { 7,  999,  2, 0 };

// caminhos minimos
int mincost3[4];

int noway3=1;
int myself3 = 3;
	
/* students to write the following two routines, and maybe some others */

void rtinit3() 
{
	int i,j;

	struct rtpkt packet;

	
	for (i=0; i<4; i++)
		for (j=0; j<4; j++)
		{
			if (j== noway3 || i == noway3)
				dt3.costs[i][j] = connectcosts3[noway3];		// no sei o caminho
			else
			{
				if (j == myself3)
					dt3.costs[i][j]= connectcosts3[i];
				else if (i == myself3)
					dt3.costs[i][j]= 2 * connectcosts3[j];
				else if (i == j)
					dt3.costs[i][j] = connectcosts3[i];	// link direto
				else 
					dt3.costs[i][j] = connectcosts3[j]* 2 + connectcosts3[i]; // vou para j, volto para 1, e vou para i (i atraves de j)
			}
		}
	
	if (TRACE>1)
	{	printf("\nTabela de distancias inicial do n %d:\n", myself3);		
		printdt3(&dt3);
	}

	
	// acha os caminhos minimos
	for(j=0;j<4;j++)
		mincost3[j] = dt3.costs[j][j];
		
		
	// envia os caminhos minimos para os vizinhos;
	for (i=0; i<4; i++)
		if (i!= myself3 && i!= noway3)
		{
			packet.destid = i;
			packet.sourceid= myself3;
			for(j=0;j<4;j++) 
				packet.mincost[j] = mincost3[j];

			tolayer2(packet);
		}
		
}




void rtupdate3(rcvdpkt)
  struct rtpkt *rcvdpkt;
  
{
	int change = 0;
	int i, j;
	struct rtpkt packet;
	
	j = rcvdpkt->sourceid;
	for(i=0; i<4; i++)
	{
		// se o caminho at J + o caminho at I for menor que o meu caminho minimo at I, atualiza a tabela
		if(mincost3[j] + rcvdpkt->mincost[i] < mincost3[i])
		{
			// atualiza os caminhos minimos
			mincost3[i] = mincost3[j] + rcvdpkt->mincost[i];
			// atualiza a tabela de distancia. Para ir at I atraves de J
			dt3.costs[i][j] = mincost3[i];
			change = 1;
		}
	}

	

	
	if (change)
	{
		if (TRACE>1)
		{	printf("\nTabela de distancias atualizada %d:\n", myself3);			
			printdt3(&dt3);
		}
		for (i=0; i<4; i++)
			if (i!= myself3 && i!= noway3)
			{
				packet.destid = i;
				packet.sourceid= myself3;
				for(j=0;j<4;j++) 
					packet.mincost[j] = mincost3[j];
				tolayer2(packet);
			}
	}
	
}


printdt3(dtptr)
  struct distance_table *dtptr;
  
{
  printf("             via     \n");
  printf("   D3 |    0     2 \n");
  printf("  ----|-----------\n");
  printf("     0|  %3d   %3d\n",dtptr->costs[0][0], dtptr->costs[0][2]);
  printf("dest 1|  %3d   %3d\n",dtptr->costs[1][0], dtptr->costs[1][2]);
  printf("     2|  %3d   %3d\n",dtptr->costs[2][0], dtptr->costs[2][2]);

}







